VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Complex"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Real As Double
Public Imaginary As Double

Public Sub Initialize(ByVal new_Real As Double, ByVal new_Imaginary As Double)
    Real = new_Real
    Imaginary = new_Imaginary
End Sub

Public Function MagnitudeSquared() As Double
    MagnitudeSquared = Real * Real + Imaginary * Imaginary
End Function

Public Function Magnitude() As Double
    Magnitude = Sqr(Real * Real + Imaginary * Imaginary)
End Function

Public Function Times(ByVal c2 As Complex) As Complex
Dim result As Complex

    Set result = New Complex
    result.Real = Me.Real * c2.Real - Me.Imaginary * c2.Imaginary
    result.Imaginary = Me.Real * c2.Imaginary + Me.Imaginary * c2.Real
    Set Times = result
End Function

Public Function Plus(ByVal c2 As Complex) As Complex
Dim result As Complex

    Set result = New Complex
    result.Real = Me.Real + c2.Real
    result.Imaginary = Me.Imaginary + c2.Imaginary
    Set Plus = result
End Function
